;; ##################################################################################
;; # ============================================================================== #
;; # MrEd Designer - misc.ss                                                        #
;; # http://mreddesigner.lozi.org                                                   #
;; # Copyright (C) Lozi Jean-Pierre, 2004 - mailto:jean-pierre@lozi.org             #
;; # Copyright (C) Peter Ivanyi, 2007                                               #
;; # ============================================================================== #
;; #                                                                                #
;; # This program is free software; you can redistribute it and/or                  #
;; # modify it under the terms of the GNU General Public License                    #
;; # as published by the Free Software Foundation; either version 2                 #
;; # of the License, or (at your option) any later version.                         #
;; #                                                                                #
;; # This program is distributed in the hope that it will be useful,                #
;; # but WITHOUT ANY WARRANTY; without even the implied warranty of                 #
;; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  #
;; # GNU General Public License for more details.                                   #
;; #                                                                                #
;; # You should have received a copy of the GNU General Public License              #
;; # along with this program; if not, write to the Free Software                    #
;; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    #
;; #                                                                                #
;; ##################################################################################

(module mreddesigner-misc mzscheme
  (require (lib "list.ss"))
  
  (provide assoc-remove)
  (define (assoc-remove lst id-list)
    (cond
      ((null? lst) '())
      ((and (list? (car lst)) (member (caar lst) id-list))
       (assoc-remove (cdr lst) id-list)
      )
      (else
       (cons (car lst) (assoc-remove (cdr lst) id-list))
      )
    )
  )
  
  (provide assoc-change)
  (define (assoc-change lst old-id new-id)
    (cond
      ((null? lst) '())
      ((and (list? (car lst)) (equal? (caar lst) old-id))
       (cons (cons new-id (cdar lst)) (assoc-change (cdr lst) old-id new-id))
      )
      (else
       (cons (car lst) (assoc-change (cdr lst) old-id new-id))
      )
    )
  )
  
  (provide remove-duplicates)
  (define (remove-duplicates lst)
    (cond
      ((null? lst) '())
      (else
       (cons (car lst) (remove-duplicates (remove (car lst) (cdr lst)))))))
  
  (provide text-split-with-empty)
  (define (text-split-with-empty str ch empty)
    (let* 
      ((idx (string-length str))
       (last #f)
       (slist '())
      )
      (do () ( (not (>= idx 0)) )
        (set! last idx)
        (do () ( (not (and (> idx 0) 
                           (not (or (and (char? ch) 
                                         (char=? (string-ref str (- idx 1)) ch))
                                    (and (list? ch) 
                                         (member (string-ref str (- idx 1)) ch))
                                )
                           )
                      )
               ) )
          (set! idx (- idx 1))
        )
        (if (>= idx 0)
          (begin
            (if (or empty
                    (and (not empty) (> (- last idx) 0)) )
              (set! slist (cons (substring str idx last) slist))
            )
            (set! idx (- idx 1))
          )
        )
      )
      slist
    )
  ) 
  
); end of module


